
enum messageid {
	MSG_USAGE,
	MSG_COPYRIGHT,
	MSG_MODE_COMP,
	MSG_MODE_EXTRACT,
	MSG_FILENAME_ECHO,
	MSG_OVERWRITE_HINT,
	MSG_USER_CANCELED,
	MSG_COMP_COMP,
	MSG_TIME_USED,
	MSG_EXTRACT_DONE,
	MSG_COMPRESS_PROGRESS,

	ERR_INVALID_PARAM,
	ERR_R_INVALID_PARAM,
	ERR_D_INVALID_PARAM,
	ERR_MODE_NOT_SET,
	ERR_MAGICHEAD_ERROR,
	ERR_OPEN_FILE_FAILED,
	ERR_ABORTED,
	ERR_WRITE_FILE_FAILED,
	MSG_MAX,

	MSG_ERR = 0x7FFFFFFF,
};

#include <string>
#include <cstdio>

std::string sys_wcs_to_mbs(const std::wstring &str) noexcept;
std::wstring sys_mbs_to_wcs(const std::string &str) noexcept;

const wchar_t *get_msg(int id);

#define msg(id, ...) wprintf(get_msg(id), ##__VA_ARGS__)

#define err(id, ...) fwprintf(stderr, get_msg(id), ##__VA_ARGS__)

extern int lang_id;

int set_lang();
