#include "unlzr.h"
#include "common.h"
#include "msg.h"

void unlzr(LZRHD* lzrh, unsigned char* flag, unsigned char* data, unsigned char *result)   //uncompress
{
	unsigned long flag_len  = lzrh->flag_bits / 2;
	long long last_repo = clock();

	for(unsigned int counter = 0; counter < flag_len; )
	{
		if(clock() - last_repo > REPORT_GAP) yx::gra::progress_bar(counter, (int)flag_len), last_repo = clock();

		unsigned char f = *flag++;

		for(int i = 0; i < 4; ++i)
		{
			if(counter >= flag_len) break;

			unsigned char n = 0;
			int           p = 0;
			unsigned char d = 0;

			switch(f>>6)
			{
				case 0:
					*result++ = *data++;
					break;
				case 1:
					n = *data++;

					while(n--)
					{
						*result++ = *data++;
					}
					break;
				case 2:
					n = *data++;
					d = *data++;

					while(n--)
					{
						*result++ = d;
					}
					break;
				case 3:
					p = *data++ << 4;
					n = *data++;
					p = p | n >> 4;
					n &= 0xF;

					while(n--)
					{
						*result = *(result - p);
						++result;
					}
			}

			f<<=2;
			++counter;
		}
	}
	msg(MSG_EXTRACT_DONE);
}

